/*
 procview.prg  -        written by Alexander Kresin

 Function call:
    TextView(file_name,y1,x1,y2,x2),
  where file_name - name of the file you want to view,
        y1,x1,y2,x2 - coordinates of a browse window.

 This function allow to view large files ( > 64K ) which can't be viewed
 by standart MEMOEDIT() function.

 Used keys:
  ESC - Exit;
  F10 - Print;
  Shift+Arrow down, Shift+Arrow up - Block operations, requires Clipper
   Tools library ( NUMAND(), KBDSTAT() - for detectind Shift key )

 This file is for PUBLIC DOMAIN. You can freely use and modify it.
*/
#include "fileio.ch"

FUNCTION TEXTVIEW ( fname, y1, x1, y2, x2 )

   LOCAL bufscr, i, lkey, prizm, poz, currpoz, bufprn, _defpa, stpech, endpech
   MEMVAR han, rez, txtbuf, buflen, maxlen, flen, strlen, preof, prbof, sme, smeend, ficol, strtmp, sblo, endblo, segme
   PRIVATE han, rez, txtbuf, buflen, maxlen, flen, strlen
   PRIVATE preof, prbof, sme, smeend, ficol, strtmp, sblo, endblo, segme

   buflen = 11000
   han = FOpen( fname )
   IF han <> - 1
      flen = FSeek( han, 0, 2 )
      FSeek( han, 0, 0 )
      strlen = x2 - x1 - 1
      txtbuf = Space( buflen + 2 )
      rez = FRead( han, @txtbuf, buflen )
      IF rez <> 0
         segme := sme := ficol := sblo := endblo := 0
         prbof = .T.
         preof = .F.
         IF rez < buflen
            preof = .T.
            txtbuf = Stuff( txtbuf, rez + 1, 2, Chr( 13 ) + Chr( 10 ) )
         ENDIF
         bufscr = SaveScreen( y1, x1, y2, x2 )
         @ y1, x1, y2, x2 BOX "Ŀ "
         @ y2, x2 - 40 SAY "ESC-Exit  F10-Print " + iif( Type( "ext_edi" ) = "C", " F4-Edit", "" )
         @ y1 + 1, x2 SAY Chr( 30 )
         @ y2 - 1, x2 SAY Chr( 31 )
         prizm = .T.
         DO WHILE .T.
            IF prizm
               DO TXTVIV WITH y1 + 1, y2 - 1, x1 + 1, x2 - 1
            ENDIF
            lkey = Inkey( 0 )
            prizm = .T.
            DO CASE
            CASE lkey = 27 .OR. lkey =- 3
               EXIT
            CASE lkey =- 9
               @ y1, x1, y2, x2 BOX "Ŀ "
               @ y1 + 1, x1 + 1 SAY "Wait, I'm printing ..."
               stpech = iif( endblo > 0, sblo, 0 )
               endpech = iif( endblo > 0, endblo, flen )
               _defpa = Set( _SET_DEFAULT )
               SET DEFAULT TO
               currpoz = FSeek( han, 0, 1 )
               FSeek( han, stpech, 0 )
               SET DEVICE TO PRINT
               SET PRINTER TO LPT1
               poz = stpech
               SetPrc( 0, 0 )
               DO WHILE poz < endpech
                  i = Min( 100, endpech - poz )
                  bufprn = Space( 100 )
                  FRead( han, @bufprn, i )
                  @ PRow(), PCol() SAY Left( bufprn, i )
                  poz += i
               ENDDO
               SET DEVICE TO SCREEN
               FSeek( han, currpoz, 0 )
               SET( _SET_DEFAULT, _defpa )
            CASE lkey = 3        // PgDn
               IF .NOT. preof .OR. smeend < rez
                  sme = smeend
               ENDIF
            CASE lkey = 24       // Cursor down
               // This two functions ( NUMAND(), KBDSTAT() ) requires Clipper Tools
               IF NUMAND( KBDSTAT(), 3 ) > 0             // If Shift pressed
                  IF endblo = 0 .OR. endblo > smeend + segme .OR. endblo < sme + segme
                     sblo := endblo := sme + segme
                  ENDIF
                  poz = At( Chr( 10 ), SubStr( txtbuf,endblo - segme + 1 ) )
                  IF poz <> 0
                     IF endblo - segme + poz > smeend
                        sme += At( Chr( 10 ), SubStr( txtbuf,sme + 1 ) )
                     ENDIF
                     endblo += poz
                  ENDIF
               ELSE
                  poz = At( Chr( 10 ), SubStr( txtbuf,sme + 1 ) )
                  IF poz <> 0
                     sme = sme + poz
                  ENDIF
               ENDIF
            CASE lkey = 18       // PgUp
               FOR i = 1 TO 20
                  poz = 0
                  IF sme > 0
                     poz = RAt( Chr( 10 ), SubStr( txtbuf,1,sme - 1 ) )
                     IF poz <> 0
                        sme = poz
                     ENDIF
                  ENDIF
                  IF poz = 0
                     IF prbof
                        sme = 0
                     ELSE
                        DO GOBACK
                     ENDIF
                  ENDIF
               NEXT
            CASE lkey = 5        // Cursor up
               // This two functions ( NUMAND(), KBDSTAT() ) requires Clipper Tools
               IF NUMAND( KBDSTAT(), 3 ) > 0        // If Shift pressed
                  IF endblo > 0
                     poz = RAt( Chr( 10 ), SubStr( txtbuf,1,endblo - segme - 1 ) )
                     IF poz <> 0
                        IF poz >= sme
                           endblo = segme + poz
                        ENDIF
                        IF endblo = sblo
                           sblo := endblo := 0
                        ENDIF
                     ELSE
                        sblo := endblo := 0
                     ENDIF
                  ENDIF
               ELSE
                  poz = 0
                  IF sme > 0
                     poz = RAt( Chr( 10 ), SubStr( txtbuf,1,sme - 1 ) )
                     IF poz <> 0
                        sme = poz
                     ENDIF
                  ENDIF
                  IF poz = 0
                     IF prbof
                        sme = 0
                     ELSE
                        DO GOBACK
                     ENDIF
                  ENDIF
               ENDIF
            CASE lkey = 4        // -->
               IF ficol < 250 - strlen
                  ficol = ficol + 1
               ENDIF
            CASE lkey = 9        // Tab
               IF ficol < 250 - strlen - 10
                  ficol = ficol + 10
               ENDIF
            CASE lkey = 19       // <--
               IF ficol > 0
                  ficol = ficol - 1
               ENDIF
            CASE lkey = 1        // Home
               ficol = 0
            CASE lkey = 6        // End
               IF maxlen > strlen
                  ficol = maxlen - strlen + 1
               ELSE
                  ficol = 0
               ENDIF
            CASE lkey = 29 .OR. lkey = 31       // Ctrl-Home
               IF .NOT. prbof
                  FSeek( han, 0, 0 )
                  rez = FRead( han, @txtbuf, buflen )
                  txtbuf = Stuff( txtbuf, buflen + 1, 2, "  " )
                  prbof = .T.
                  preof = .F.
               ENDIF
               segme := sme := 0
            CASE lkey = 23 .OR. lkey = 30       // Ctrl-End
               IF .NOT. preof
                  segme = FSeek( han, flen - buflen, 0 )
                  rez = FRead( han, @txtbuf, buflen )
                  preof = .T.
                  prbof = .F.
                  prizm = .F.
                  sme = buflen - 1
                  txtbuf = Stuff( txtbuf, buflen + 1, 2, Chr( 13 ) + Chr( 10 ) )
                  KEYBOARD Chr( 18 )
               ENDIF
               //     CASE lkey=28
               //       DO CALCUL
               //     CASE lkey=-10
               //       DO EXT_PRG
               OTHERWISE
               prizm = .F.
            ENDCASE
         ENDDO
         RestScreen( y1, x1, y2, x2, bufscr )
      ENDIF
      FClose( han )
   ENDIF

   RETURN ( lkey == - 3 )

PROCEDURE TXTVIV ( y1, y2, x1, x2 )

   LOCAL i, poz, pozend, strf, pozold, slen

   poz = sme + 1
   maxlen = 0
   @ y1 + 1, x2 + 1, y2 - 1, x2 + 1 BOX ""
   @ y1 + Int( ( iif(buflen > flen,0,FSeek(han,0,1 ) - buflen ) + sme ) * ( y2 - y1 - 2 )/flen ) + 1, x2 + 1 SAY Chr( 254 )
   FOR i = 1 TO y2 - y1 + 1
      pozend = At( Chr( 10 ), SubStr( txtbuf,poz ) )
      IF pozend > maxlen
         maxlen = pozend
      ENDIF
      IF pozend = 0
         IF preof
            @ y1 + i - 1, x1 CLEAR TO y2, x2
            EXIT
         ELSE
            pozold = FSeek( han, 0, 1 )
            poz = poz - sme
            IF pozold + sme >= flen
               FSeek( han, flen - buflen, 0 )
               rez = FRead( han, @txtbuf, buflen )
               preof = .T.
               sme = pozold - flen + sme
               txtbuf = Stuff( txtbuf, buflen + 1, 2, Chr( 13 ) + Chr( 10 ) )
            ELSE
               FSeek( han, - ( buflen - sme ), 1 )
               segme = FSeek( han, 0, 1 )
               rez = FRead( han, @txtbuf, buflen )
               preof = .F.
               sme = 0
            ENDIF
            prbof = .F.
            poz = poz + sme
            pozend = At( Chr( 10 ), SubStr( txtbuf,poz ) )
         ENDIF
      ENDIF
      pozend = pozend + poz - 1
      COLORSELECT( iif( poz + segme > sblo .AND. poz + segme < endblo,1,0 ) )
      slen = iif( pozend - poz - ficol > strlen, strlen, pozend - poz - ficol - 1 )
      IF slen > 0
         @ y1 + i - 1, x1 SAY SubStr( txtbuf, poz + ficol, slen )
      ENDIF
      IF slen < strlen
         @ y1 + i - 1, x1 + iif( slen > 0, slen, 0 ) CLEAR TO y1 + i - 1, x2
      ENDIF
      poz = pozend + 1
   NEXT
   COLORSELECT( 0 )
   smeend = poz - 1

   RETURN

PROCEDURE GOBACK

   LOCAL pozold, poznew

   pozold = FSeek( han, 0, 1 )
   IF pozold < buflen * 2 - smeend
      poznew = FSeek( han, 0, 0 )
   ELSE
      IF preof
         poznew = FSeek( han, - ( buflen + rez - smeend ), 1 )
      ELSE
         poznew = FSeek( han, - ( buflen * 2 - smeend ), 1 )
      ENDIF
   ENDIF
   rez = FRead( han, @txtbuf, buflen )
   segme = poznew
   IF preof
      txtbuf = Stuff( txtbuf, buflen + 1, 2, "  " )
   ENDIF
   preof = .F.
   IF pozold < buflen * 2 - smeend
      sme = pozold - buflen + sme
   ELSE
      sme = buflen - smeend + sme
   ENDIF
   sme = RAt( Chr( 10 ), SubStr( txtbuf,1,sme - 1 ) )
   IF poznew = 0
      prbof = .T.
   ENDIF

   RETURN
